diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/traffic-control/test/cobalt-queue-disc-test-suite.cc ns-3.31/src/traffic-control/test/cobalt-queue-disc-test-suite.cc
--- ns-3.30.1/src/traffic-control/test/cobalt-queue-disc-test-suite.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/traffic-control/test/cobalt-queue-disc-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
@@ -140,8 +140,6 @@
 
   Address dest;
 
-  NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("MinBytes", UintegerValue (pktSize)), true,
-                         "Verify that we can actually set the attribute MinBytes");
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("Interval", StringValue ("50ms")), true,
                          "Verify that we can actually set the attribute Interval");
   NS_TEST_EXPECT_MSG_EQ (queue->SetAttributeFailSafe ("Target", StringValue ("4ms")), true,
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/traffic-control/test/codel-queue-disc-test-suite.cc ns-3.31/src/traffic-control/test/codel-queue-disc-test-suite.cc
--- ns-3.30.1/src/traffic-control/test/codel-queue-disc-test-suite.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/traffic-control/test/codel-queue-disc-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
@@ -37,7 +37,7 @@
 /* needed shift to get a Q0.32 number from rec_inv_sqrt */
 #define REC_INV_SQRT_SHIFT_ns3 (32 - REC_INV_SQRT_BITS_ns3)
 
-static uint16_t _codel_Newton_step (uint32_t count, uint16_t rec_inv_sqrt)
+static uint16_t _codel_Newton_step (uint16_t rec_inv_sqrt, uint32_t count)
 {
   uint32_t invsqrt = ((uint32_t)rec_inv_sqrt) << REC_INV_SQRT_SHIFT_ns3;
   uint32_t invsqrt2 = ((uint64_t)invsqrt * invsqrt) >> 32;
@@ -67,8 +67,9 @@
    *
    * \param p packet
    * \param addr address
+   * \param ecnCapable ECN capable
    */
-  CodelQueueDiscTestItem (Ptr<Packet> p, const Address & addr);
+  CodelQueueDiscTestItem (Ptr<Packet> p, const Address & addr, bool ecnCapable);
   virtual ~CodelQueueDiscTestItem ();
   virtual void AddHeader (void);
   virtual bool Mark(void);
@@ -86,10 +87,12 @@
    * Disable default implementation to avoid misuse
    */
   CodelQueueDiscTestItem &operator = (const CodelQueueDiscTestItem &);
+  bool m_ecnCapablePacket; ///< ECN capable packet?
 };
 
-CodelQueueDiscTestItem::CodelQueueDiscTestItem (Ptr<Packet> p, const Address & addr)
-  : QueueDiscItem (p, addr, 0)
+CodelQueueDiscTestItem::CodelQueueDiscTestItem (Ptr<Packet> p, const Address & addr, bool ecnCapable)
+  : QueueDiscItem (p, addr, ecnCapable),
+    m_ecnCapablePacket (ecnCapable)
 {
 }
 
@@ -105,6 +108,10 @@
 bool
 CodelQueueDiscTestItem::Mark (void)
 {
+  if (m_ecnCapablePacket)
+    {
+      return true;
+    }
   return false;
 }
 
@@ -173,17 +180,17 @@
   p6 = Create<Packet> (pktSize);
 
   NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize().GetValue (), 0 * modeSize, "There should be no packets in queue");
-  queue->Enqueue (Create<CodelQueueDiscTestItem> (p1, dest));
+  queue->Enqueue (Create<CodelQueueDiscTestItem> (p1, dest, false));
   NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize().GetValue (), 1 * modeSize, "There should be one packet in queue");
-  queue->Enqueue (Create<CodelQueueDiscTestItem> (p2, dest));
+  queue->Enqueue (Create<CodelQueueDiscTestItem> (p2, dest, false));
   NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize().GetValue (), 2 * modeSize, "There should be two packets in queue");
-  queue->Enqueue (Create<CodelQueueDiscTestItem> (p3, dest));
+  queue->Enqueue (Create<CodelQueueDiscTestItem> (p3, dest, false));
   NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize().GetValue (), 3 * modeSize, "There should be three packets in queue");
-  queue->Enqueue (Create<CodelQueueDiscTestItem> (p4, dest));
+  queue->Enqueue (Create<CodelQueueDiscTestItem> (p4, dest, false));
   NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize().GetValue (), 4 * modeSize, "There should be four packets in queue");
-  queue->Enqueue (Create<CodelQueueDiscTestItem> (p5, dest));
+  queue->Enqueue (Create<CodelQueueDiscTestItem> (p5, dest, false));
   NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize().GetValue (), 5 * modeSize, "There should be five packets in queue");
-  queue->Enqueue (Create<CodelQueueDiscTestItem> (p6, dest));
+  queue->Enqueue (Create<CodelQueueDiscTestItem> (p6, dest, false));
   NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize().GetValue (), 6 * modeSize, "There should be six packets in queue");
 
   NS_TEST_EXPECT_MSG_EQ (queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::OVERLIMIT_DROP),
@@ -293,9 +300,9 @@
   queue->Initialize ();
 
   Enqueue (queue, pktSize, 500);
-  queue->Enqueue (Create<CodelQueueDiscTestItem> (p1, dest));
-  queue->Enqueue (Create<CodelQueueDiscTestItem> (p2, dest));
-  queue->Enqueue (Create<CodelQueueDiscTestItem> (p3, dest));
+  queue->Enqueue (Create<CodelQueueDiscTestItem> (p1, dest, false));
+  queue->Enqueue (Create<CodelQueueDiscTestItem> (p2, dest, false));
+  queue->Enqueue (Create<CodelQueueDiscTestItem> (p3, dest, false));
 
   NS_TEST_EXPECT_MSG_EQ (queue->GetCurrentSize().GetValue (), 500 * modeSize, "There should be 500 packets in queue");
   NS_TEST_EXPECT_MSG_EQ (queue->GetStats ().GetNDroppedPackets (CoDelQueueDisc::OVERLIMIT_DROP),
@@ -308,7 +315,7 @@
   Address dest;
   for (uint32_t i = 0; i < nPkt; i++)
     {
-      queue->Enqueue (Create<CodelQueueDiscTestItem> (Create<Packet> (size), dest));
+      queue->Enqueue (Create<CodelQueueDiscTestItem> (Create<Packet> (size), dest, false));
     }
 }
 
@@ -337,23 +344,17 @@
 
   // Spot check a few points in the expected operational range of
   // CoDelQueueDisc's m_count and m_recInvSqrt variables
-  uint32_t count = 2;
-  uint16_t recInvSqrt = 65535;
-  queue->m_count = count;
-  queue->m_recInvSqrt = recInvSqrt;
-  queue->NewtonStep ();
-  // Test that ns-3 value is exactly the same as the Linux value
-  NS_TEST_ASSERT_MSG_EQ (_codel_Newton_step (count, recInvSqrt), queue->m_recInvSqrt,
-                         "ns-3 NewtonStep() fails to match Linux equivalent");
-
-  count = 4;
-  recInvSqrt = 36864;
-  queue->m_count = count;
-  queue->m_recInvSqrt = recInvSqrt;
-  queue->NewtonStep ();
-  // Test that ns-3 value is exactly the same as the Linux value
-  NS_TEST_ASSERT_MSG_EQ (_codel_Newton_step (count, recInvSqrt), queue->m_recInvSqrt,
+  uint16_t result;
+  for (uint16_t recInvSqrt = 0xff; recInvSqrt > 0; recInvSqrt /= 2)
+    {
+      for (uint32_t count = 1; count < 0xff; count *= 2)
+        {
+           result = queue->NewtonStep (recInvSqrt, count);
+           // Test that ns-3 value is exactly the same as the Linux value
+           NS_TEST_ASSERT_MSG_EQ (_codel_Newton_step (recInvSqrt, count), result,
                          "ns-3 NewtonStep() fails to match Linux equivalent");
+        }
+    }
 }
 
 /**
@@ -373,7 +374,7 @@
    * \param t
    * \returns the codel control law
    */
-  uint32_t _codel_control_law (Ptr<CoDelQueueDisc> queue, uint32_t t);
+  uint32_t _codel_control_law (uint32_t t, uint32_t interval, uint32_t recInvSqrt);
 };
 
 CoDelQueueDiscControlLawTest::CoDelQueueDiscControlLawTest ()
@@ -384,9 +385,9 @@
 // The following code borrowed from Linux codel.h,
 // except the addition of queue parameter
 uint32_t
-CoDelQueueDiscControlLawTest::_codel_control_law (Ptr<CoDelQueueDisc> queue, uint32_t t)
+CoDelQueueDiscControlLawTest::_codel_control_law (uint32_t t, uint32_t interval, uint32_t recInvSqrt)
 {
-  return t + _reciprocal_scale (queue->Time2CoDel (queue->m_interval), queue->m_recInvSqrt << REC_INV_SQRT_SHIFT_ns3);
+  return t + _reciprocal_scale (interval, recInvSqrt << REC_INV_SQRT_SHIFT_ns3);
 }
 // End Linux borrrow
 
@@ -395,18 +396,19 @@
 {
   Ptr<CoDelQueueDisc> queue = CreateObject<CoDelQueueDisc> ();
 
-  /* Spot check a few points of m_dropNext
-   The integer approximations in Linux should be within
-   2% of the true floating point value obtained in ns-3
-   */
-  uint32_t dropNextTestVals [4] = {292299, 341128, 9804717, 55885007};
-
-  for (int i = 0; i < 4; ++i)
-    {
-      uint32_t ns3Result = queue->ControlLaw(dropNextTestVals[i]); 
-      uint32_t linuxResult = _codel_control_law(queue, dropNextTestVals[i]); 
-      NS_TEST_EXPECT_MSG_EQ((0.98 * ns3Result < linuxResult && linuxResult < 1.02 * ns3Result), true, 
-        "Linux result should stay within 2% of ns-3 result"); 
+  // Check a few points within the operational range of ControlLaw
+  uint32_t interval = queue->Time2CoDel (MilliSeconds (100));
+
+  uint32_t codelTimeVal;
+  for (Time timeVal = Seconds (0); timeVal <= Seconds (20); timeVal += MilliSeconds (100))
+    {
+      for (uint16_t recInvSqrt = 0xff; recInvSqrt > 0; recInvSqrt /= 2)
+        {
+          codelTimeVal = queue->Time2CoDel (timeVal);
+          uint32_t ns3Result = queue->ControlLaw (codelTimeVal, interval, recInvSqrt); 
+          uint32_t linuxResult = _codel_control_law (codelTimeVal, interval, recInvSqrt); 
+          NS_TEST_EXPECT_MSG_EQ (ns3Result, linuxResult, "Linux result for ControlLaw should equal ns-3 result");
+        }
     }
 }
 
@@ -516,7 +518,7 @@
   Address dest;
   for (uint32_t i = 0; i < nPkt; i++)
     {
-      queue->Enqueue (Create<CodelQueueDiscTestItem> (Create<Packet> (size), dest));
+      queue->Enqueue (Create<CodelQueueDiscTestItem> (Create<Packet> (size), dest, false));
     }
 }
 
